NmAbstractServer subclass: #NmWorldMapServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Server-MapServer'!

!NmWorldMapServer methodsFor: 'actions' stamp: 'mu 3/17/2003 00:19'!
getMapStringNamed: mapName 
	^ self readWriter getCsvStringFromFile: mapName! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'my 4/9/2003 22:29'!
listAllMapNames
	^self readWriter listMapCsvFileNamesFromDirectory
	
	! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'mu 3/17/2003 00:28'!
putMapString: mapCSVString named: mapName 
	self readWriter putCsvString: mapCSVString toFile: mapName.
	^ nil! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'my 4/9/2003 22:10'!
register: nmURLString on: mapName 
	| readWriter mapCSV mapDict newPoint newCSV |
	readWriter _ self readWriter.
	mapCSV _ readWriter getCsvStringFromFile: mapName.
	mapCSV
		ifNil: [^ nil].
	mapDict _ readWriter parseCSVString: mapCSV.
	newPoint _ self randomPointFrom: (mapDict keys collect: [:each | Point readFrom: each]).
	newPoint
		ifNil: [^ nil].
	mapDict at: nmURLString put: newPoint.
	newCSV _ readWriter csvStringFrom: mapDict.
	readWriter putCsvString: newCSV toFile: mapName.
	^ newPoint
	! !


!NmWorldMapServer methodsFor: 'factory' stamp: 'mu 3/17/2003 00:12'!
readWriter
	^NmWorldInfoReadWriter! !


!NmWorldMapServer methodsFor: 'private' stamp: 'mu 3/17/2003 00:33'!
randomPointFrom: existingPoints 

	|  maxPoint minPoint xSize ySize points |
	
	maxPoint _ existingPoints inject: 0@0 into: [:sum :eachPoint | sum max: eachPoint ].
	minPoint _ existingPoints inject: maxPoint into: [:sum :eachPoint | sum min: eachPoint ]. 
	
	xSize _ (maxPoint x - minPoint x) + 1.
	ySize _ (maxPoint y - minPoint y) + 1.
	
	points _ OrderedCollection new: (xSize * ySize).
	minPoint x to: maxPoint x do: [:x |
		minPoint y to: maxPoint y do: [:y |
			points add: (Point x: x y: y)]].

	points removeAll: existingPoints.
	points isEmpty ifTrue: [^nil].
	^points atRandom! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapServer class
	instanceVariableNames: ''!

!NmWorldMapServer class methodsFor: 'registering' stamp: 'my 4/9/2003 22:10'!
registerServices
	self registerServiceNamed: #'putMapString:named:' paramNames: #(#mapCSVString #mapName ).
	self registerServiceNamed: #'getMapStringNamed:' paramNames: #(#mapName ).
	self registerServiceNamed: #listAllMapNames paramNames: #().
	self registerServiceNamed: #'register:on:' paramNames: #(#nmURLString #mapName )! !


!NmWorldMapServer class methodsFor: 'class initialization' stamp: 'mu 3/12/2003 00:19'!
initialize
	self basicInitialize! !

NmWorldMapServer initialize!