Model subclass: #NmAbstractSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmAbstractSettings class
	instanceVariableNames: 'properties '!

!NmAbstractSettings class methodsFor: 'class initialization' stamp: 'ns 1/22/2003 18:42'!
initialize
	"NmSettings initialize"
	properties _ nil.
	self resetDefaults! !

!NmAbstractSettings class methodsFor: 'class initialization' stamp: 'kuri-t 2/20/2003 16:13'!
resetDefaults
	| keys |
	keys _ self properties keys.
	keys
		do: [:eachKey | self properties removeKey: eachKey].
	keys
		do: [:eachKey | self perform: #changed: with: eachKey asSymbol]! !


!NmAbstractSettings class methodsFor: 'accessing' stamp: 'mu 3/12/2003 00:39'!
adminServerUrl
	^ self properties at: #adminServerUrl ifAbsentPutValue: self defaultAdminServerUrl! !

!NmAbstractSettings class methodsFor: 'accessing' stamp: 'mu 3/12/2003 00:40'!
adminServerUrl: aValue 
	self properties at: #adminServerUrl put: aValue asString.
	self changed: #adminServerUrl.
	^ true! !

!NmAbstractSettings class methodsFor: 'accessing' stamp: 'mu 3/10/2003 18:15'!
mapPath
	| mapPath |
	mapPath _ self properties
				at: #mapPath
				ifAbsent: [].
	(mapPath isNil
			or: [mapPath isEmpty])
		ifTrue: [mapPath _ self properties at: #mapPath put: self defaultMapPath].
	^ mapPath! !

!NmAbstractSettings class methodsFor: 'accessing' stamp: 'mu 3/10/2003 18:16'!
mapPath: aValue 
	(aValue isNil
			or: [aValue asString isEmpty])
		ifTrue: [^ false].
	self properties at: #mapPath put: aValue asString.
	self changed: #mapPath.
	^ true! !

!NmAbstractSettings class methodsFor: 'accessing' stamp: 'ns 1/22/2003 19:14'!
properties
	properties ifNil: [properties _ NmProperties new].
	^properties! !


!NmAbstractSettings class methodsFor: 'storing/loading' stamp: 'ns 1/22/2003 18:44'!
load
	"NmSettings load"
	| readFileStream |
	(FileDirectory default fileExists: self iniFileName) ifFalse: [self store].
	readFileStream _ FileDirectory default readOnlyFileNamed: self iniFileName.
	NmTranscript crShow: '## NmSetting was loaded: ', self iniFileName.
	^Object readSixxFrom: readFileStream contents.
	! !

!NmAbstractSettings class methodsFor: 'storing/loading' stamp: 'ns 1/22/2003 18:46'!
store 
	"NmSettings store"
	| writeFileStream |
	writeFileStream _ FileDirectory default forceNewFileNamed: self iniFileName.
	writeFileStream nextPutAll: self sixxString.
	writeFileStream close.! !


!NmAbstractSettings class methodsFor: 'constants' stamp: 'mu 3/10/2003 18:14'!
defaultAdminServerPort
	^ 80! !

!NmAbstractSettings class methodsFor: 'constants' stamp: 'mu 3/22/2003 11:45'!
defaultAdminServerUrl
	^ 'http://swikis.ddo.jp:8823/NetMorphAdminServer' copy.! !

!NmAbstractSettings class methodsFor: 'constants' stamp: 'mu 3/10/2003 18:16'!
defaultMapPath
	^ FileDirectory default pathName copy! !

!NmAbstractSettings class methodsFor: 'constants' stamp: 'ns 1/22/2003 18:48'!
iniFileName
	^self name, '.ini' copy! !

!NmAbstractSettings class methodsFor: 'constants' stamp: 'my 4/9/2003 22:21'!
resolverPrefix
	^'RESOLVER_' copy! !


AlignmentMorph subclass: #NmAbstractSettingsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

!NmAbstractSettingsMorph methodsFor: 'actions' stamp: 'mu 2/19/2003 15:55'!
resetDefaults
	self settingClass resetDefaults.
	"self delete"! !

!NmAbstractSettingsMorph methodsFor: 'actions' stamp: 'ns 1/22/2003 17:23'!
save
	self settingClass store! !


!NmAbstractSettingsMorph methodsFor: 'testing' stamp: 'ns 1/22/2003 16:35'!
isOn
	^false! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmAbstractSettingsMorph class
	instanceVariableNames: ''!

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'my 4/9/2003 23:08'!
buildButtonOn: morph action: selector label: labelString help: helpString 
	| button |
	button _ (PluggableButtonMorph
				on: morph
				getState: #isOn
				action: selector)
				label: labelString.
	button hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 setBalloonText: helpString.
	^ button! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'mu 2/19/2003 15:43'!
buildResetDefaultButtonRowOn: morph
	| default row |
	default _ (PluggableButtonMorph on: morph getState: #isOn action: #resetDefaults) label: 'Reset to default values'.

	default
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'set NmSettings to default values'.

	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		addAllMorphs: (Array with: default );
		extent: 120@35.
	
	^row! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'mu 5/19/2003 15:16'!
buildRow: leftMorph with: rightMorph
	| rowMorph |
	rowMorph _ AlignmentMorph newRow.
	rowMorph addMorphBack: leftMorph.
	rowMorph addMorphBack: rightMorph.
	^ rowMorph! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'ns 1/22/2003 16:35'!
buildRowLabeled: labelName 
	| rowMorph label |
	rowMorph _ AlignmentMorph newRow vResizing: #shrinkWrap.
	label _ TextMorph new contents: labelName;
				 lock.
	rowMorph addMorphBack: label.
	^ rowMorph! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'mu 5/29/2003 12:48'!
buildTextField: selector 
	| getter setter textField |
	getter _ selector.
	setter _ (getter , ':') asSymbol.
	textField _ PluggableTextMorph
				on: self settingClass
				text: getter
				accept: setter.
	textField acceptOnCR: true.
	textField hideScrollBarIndefinitely.
	textField borderWidth: 1.
	textField extent: 600@20.
	textField hResizing: #spaceFill;
		 vResizing: #spaceFill.
	^ textField! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'ns 1/22/2003 17:18'!
createSystemWindow
	"NmAbstractSettingMorph createSystemWindow openInWorld."
	| inst window |
	inst _ self new.
	inst listDirection: #topToBottom.
	inst hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	window _ (SystemWindow labelled: self labelString)
				model: Model new.
	window
		addMorph: inst
		frame: (0 @ 0 corner: 1 @ 1).
	window extent: self windowExtent.
	^ window! !


!NmAbstractSettingsMorph class methodsFor: 'instance creation' stamp: 'ns 1/22/2003 16:52'!
open
	"NmSettingMorph open"
	^ self createWindow openInWorldExtent: self windowExtent! !


!NmAbstractSettingsMorph class methodsFor: 'factory' stamp: 'ns 1/22/2003 16:41'!
settingClass
	self subclassResponsibility! !


!NmAbstractSettingsMorph class methodsFor: 'constants' stamp: 'mu 5/29/2003 12:54'!
windowExtent
	self subclassResponsibility! !


Object subclass: #NmCSVReadWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmCSVReadWriter class
	instanceVariableNames: ''!

!NmCSVReadWriter class methodsFor: 'actions' stamp: 'mu 3/15/2003 02:03'!
csvStringFrom: mapDictionary 
	| stream |
	mapDictionary isNil ifTrue: [^''].
	stream _ WriteStream on: String new.
	mapDictionary
		keysAndValuesDo: [:key :value | 
			stream nextPutAll: key asString.
			stream nextPut: $,.
			stream nextPutAll: value asString.
			stream nextPut: Character cr].
	^ stream contents! !

!NmCSVReadWriter class methodsFor: 'actions' stamp: 'mu 3/16/2003 23:55'!
parseCSVString: aString
	| newMap stream |
	newMap := Dictionary new.
	aString isNil ifTrue:[^newMap].
	stream _ ReadStream on: aString.
	[stream atEnd]
		whileFalse: [| line lineStream key value | 
			line _ stream nextLine.
			(line includes: $,)
				ifTrue: [lineStream _ ReadStream on: line.
					key _ (lineStream upTo: $,) withBlanksTrimmed.
					value _ lineStream upToEnd withBlanksTrimmed.
					newMap at: key put: value]].
	^newMap! !


Error subclass: #NmError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!


Object subclass: #NmFlapSetup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!
!NmFlapSetup commentStamp: '<historical>' prior: 0!
To add aMorph to NetMorph Flap;

1)	make a morph.
2)	add the definition to NmFlapSetup class>>quadsDefiningNetMorphFlap.
3)	do "NmFlapSetup reInstall.".

Browser newOnClass: NmFlapSetup class selector: #quadsDefiningNetMorphFlap!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmFlapSetup class
	instanceVariableNames: ''!

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'ns 2/14/2003 14:05'!
addFlap
	"NmFlapSetup addFlap."
	| aFlapTab |
	(ActiveWorld submorphs
			detect: [:each | (each isKindOf: FlapTab)
					and: [each flapID = self tabName]]
			ifNone: []) notNil
		ifTrue: [^ nil].
	aFlapTab _ self newNetMorphFlap.
	aFlapTab setBalloonText: self balloonTextForFlaps.
	Flaps addGlobalFlap: aFlapTab.
	ActiveWorld addGlobalFlaps.
	aFlapTab
		changeTabText: (Vocabulary eToyVocabulary translatedWordingFor: self tabName asSymbol).
	^ aFlapTab! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'ns 2/14/2003 13:38'!
destroyFlap
	"NmFlapSetup destroyFlap."
	"PartsBin initialize."
	(ActiveWorld flapTabs
		select: [:each | each flapID = self tabName])
		do: [:each | each destroyFlap]! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'kuri-t 2/20/2003 12:26'!
reInstall
	"NmFlapSetup reInstall."
	NmFlapSetup destroyFlap.
	PartsBin initialize.
	NmFlapSetup addFlap! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'ns 10/7/2002 16:59'!
setUp
	| aFlapTab |
	(aFlapTab _ ActiveWorld submorphs
					detect: [:each | (each isKindOf: FlapTab)
							and: [each flapID = NmFlapSetup tabName]]
					ifNone: []) isNil
		ifFalse: [aFlapTab isGlobalFlap
				ifTrue: [Flaps removeFlapTab: aFlapTab keepInList: false.
					aFlapTab currentWorld reformulateUpdatingMenus]
				ifFalse: [aFlapTab referent isInWorld
						ifTrue: [aFlapTab referent delete].
					aFlapTab delete]].
	PartsBin initialize.
	NmFlapSetup initialize! !


!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 9/13/2002 15:11'!
balloonTextForFlaps
	^ 'NetMorph tools!!' copy! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 9/13/2002 15:12'!
flapColor
	^ Color
		r: 0.516
		g: 0.452
		b: 1.0! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 2/14/2003 13:22'!
tabSymbol
	^ #NetMorph! !


!NmFlapSetup class methodsFor: 'predefined flaps' stamp: 'mu 2/19/2003 14:37'!
quadsDefiningNetMorphFlap
	^ NmServerManager isWarpServerInstalled
		ifTrue: [NmServerManager isMapAndNameServersInstalled
				ifTrue: [self quadsDefiningNetMorphFlapForClientServer]
				ifFalse: [self quadsDefiningNetMorphFlapForClient]]
		ifFalse: [self quadsDefiningNetMorphFlapForServer]! !


!NmFlapSetup class methodsFor: 'private' stamp: 'ns 9/13/2002 15:22'!
newNetMorphFlap
	| aFlapTab aStrip |
	aStrip _ PartsBin newPartsBinWithOrientation: #leftToRight from: self quadsDefiningNetMorphFlap.
	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab
		setName: self tabName
		edge: #bottom
		color: self flapColor.
	aStrip extent: self currentWorld width @ 78.
	aFlapTab position: 104 @ (self currentWorld height - aFlapTab height).
	aStrip beFlap: true.
	aStrip color: self flapColor.
	aStrip autoLineLayout: true.
	^ aFlapTab! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 5/16/2003 19:02'!
quadsDefiningNetMorphFlapForClient
	"Answer a fully-instantiated flap named 'NetMorph' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"
		"class					makeThumbnail		nameInFlap		ballonText"
	^ #(
		(NmSettingsMorph		createWindow			'Setting'			'NetMorph settings')
		(NmWorldMapMorph	createWindow			'WorldMap'		'organize the World Map')
	)! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 2/19/2003 14:38'!
quadsDefiningNetMorphFlapForClientServer
	^self quadsDefiningNetMorphFlapForClient, self quadsDefiningNetMorphFlapForServer
! !

!NmFlapSetup class methodsFor: 'private' stamp: 'kuri-t 2/20/2003 12:17'!
quadsDefiningNetMorphFlapForServer
	"Answer a fully-instantiated flap named 'NetMorph' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"
		"class					makeThumbnail		nameInFlap		ballonText"
	^ #(
		(NmServerSettingsMorph		createWindow			'Server Setting'			'NetMorph Server settings')
	)! !

!NmFlapSetup class methodsFor: 'private' stamp: 'ns 2/14/2003 13:23'!
tabName
	^ self tabSymbol! !


Notification subclass: #NmNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!


Object subclass: #NmProperties
	instanceVariableNames: 'dictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!
!NmProperties commentStamp: '<historical>' prior: 0!
I represent an appication specific name/value properties.

My subclasses will have many default value provider methods. 
Or just use #at: #at:put like a normal dictionary.

#creator
[:masashi | ^umezawa] 
#version 0.4 M.U. 11/21/1999 22:12!


!NmProperties methodsFor: 'initialize-release' stamp: 'ns 1/20/2003 18:45'!
initialize
	"do nothing"! !


!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey 
	^ self dictionary
		at: aKey
		ifAbsent: []! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey ifAbsent: aBlock 
	^ self dictionary at: aKey ifAbsent: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey ifAbsentPut: aBlock 
	^ self dictionary at: aKey ifAbsentPut: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
at: aKey ifAbsentPutValue: aValue 
	^ self dictionary
		at: aKey
		ifAbsent: [self dictionary at: aKey put: aValue]! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
at: aKey put: aValue 
	| val |
	val _ aValue.
	"for self class >> newFrom: aKeyValueArray"
	aValue == #true
		ifTrue: [val _ true].
	aValue == #false
		ifTrue: [val _ false].
	aValue == #nil
		ifTrue: [val _ nil].
	^ self dictionary at: aKey put: val! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
disable: aKey 
	^ self at: aKey put: false! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
enable: aKey 
	^ self at: aKey put: true! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
includesKey: aKey 
	^ self dictionary includesKey: aKey! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
inherit: aNmProperties 
	aNmProperties
		keysAndValuesDo: [:key :value | self at: key ifAbsentPutValue: value]! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
keys
	^ self dictionary keys! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
overridden: aNmProperties 
	aNmProperties
		keysAndValuesDo: [:key :value | self at: key put: value]! !

!NmProperties methodsFor: 'actions' stamp: 'mu 2/12/2003 16:53'!
removeKey: aKey
	^ self dictionary
		removeKey: aKey! !

!NmProperties methodsFor: 'actions' stamp: 'mu 2/12/2003 16:53'!
removeKey: aKey ifAbsent: aBlock
	^ self dictionary
		removeKey: aKey ifAbsent: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
size
	^ self dictionary size! !


!NmProperties methodsFor: 'converting' stamp: 'ns 1/20/2003 18:46'!
asArray
	| idx outArr |
	idx _ 0.
	outArr _ Array new: self size.
	self dictionary
		associationsDo: [:assoc | outArr
				at: (idx _ idx + 1)
				put: (Array with: assoc key with: assoc value)].
	^ outArr! !

!NmProperties methodsFor: 'converting' stamp: 'ns 1/20/2003 18:46'!
fromArray: aKeyValueArray 
	"brace expressions are no longer used for Squeak 2.7+: M.U. 11/21/1999 22:15"
	"instead use: #(#(key1 value1) #(key2 value2))"
	| dict |
	dict _ self defaultDictionaryClass new: aKeyValueArray size.
	aKeyValueArray
		do: [:each | dict at: each first put: each last].
	self dictionary: dict! !


!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
do: aBlock 
	^ self dictionary do: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
keysAndValuesDo: aBlock 
	^ self dictionary keysAndValuesDo: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
keysDo: aBlock 
	^ self dictionary keysDo: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
valuesDo: aBlock 
	^ self dictionary valuesDo: aBlock! !


!NmProperties methodsFor: 'accessing' stamp: 'ns 1/20/2003 18:46'!
dictionary
	dictionary isNil
		ifTrue: [dictionary _ self defaultDictionaryClass new].
	^ dictionary! !

!NmProperties methodsFor: 'accessing' stamp: 'ns 1/20/2003 18:46'!
dictionary: aValue 
	dictionary _ aValue! !


!NmProperties methodsFor: 'factory' stamp: 'ns 1/20/2003 18:46'!
defaultDictionaryClass
	^ IdentityDictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmProperties class
	instanceVariableNames: ''!

!NmProperties class methodsFor: 'instance creation' stamp: 'ns 1/20/2003 18:45'!
new
	^ super new initialize! !

!NmProperties class methodsFor: 'instance creation' stamp: 'ns 1/20/2003 18:45'!
newFrom: aKeyValueArray 
	"brace expressions are no longer used for Squeak 2.7+: M.U. 11/21/1999 22:15"
	"instead use: #(#(key1 value1) #(key2 value2))"
	^ self new fromArray: aKeyValueArray! !


!NmProperties class methodsFor: 'examples' stamp: 'ns 1/20/2003 18:45'!
example1
	"NmProperties example1"
	| props |
	props _ NmProperties newFrom: #(#(#SqIsCool #true) #(#defaultPassword #fooBar) #(#greeting 'Hi!!') ).
	^ props! !

!NmProperties class methodsFor: 'examples' stamp: 'ns 1/20/2003 18:45'!
example2
	"NmProperties example2"
	| props |
	props _ self example1.
	props disable: #SqIsCool.
	^ props
		overridden: (NmProperties newFrom: #(#(#SqueakVersion 2.7) #(#greeting 'Hello!!') ))! !


Object subclass: #NmServerManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmServerManager class
	instanceVariableNames: ''!

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/6/2003 01:08'!
isMapAndNameServersInstalled
	"NmServerManager isMapAndNameServersInstalled"
	^ ((Smalltalk includesKey: #SoapServerSetup)
			and: [Smalltalk includesKey: #NmWorldMapServer])
		and: [Smalltalk includesKey: #NmResolverServer]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:45'!
isWarpServerInstalled
	"NmServerManager isWarpServerInstalled"
	^ Smalltalk includesKey: #NmRemoteServer! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/6/2003 01:39'!
startAdminServer
	"NmServerManager startAdminServer"
	| setup |
	self isMapAndNameServersInstalled
		ifTrue: [(setup _ self soapServerSetup)
				ifNotNil: [setup restartAt: #http port: NmServerSettings adminServerPort]]
		ifFalse: [self error: 'Map and NameServer are not installed']! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/6/2003 01:38'!
startWarpServer
	| setup |
	self isWarpServerInstalled
		ifTrue: [(setup _ self warpServerSetup)
				ifNotNil: [self stopWarpServer.
					setup default restart: NmSettings warpPort]]
		ifFalse: [self error: 'WarpServer is not installed']! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/6/2003 01:39'!
stopAdminServer
	"NmServerManager stopAdminServer"
	| setup |
	(setup _ self soapServerSetup)
		ifNotNil: [setup
				stop: (Array with: #http)]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/6/2003 01:38'!
stopWarpServer
	| setup openSockets |
	(setup _ self warpServerSetup)
		ifNotNil: [setup default stop.
			openSockets _ Socket allInstances
						select: [:each | each isConnected].
			(openSockets
				select: [:each | each remotePort = NmSettings warpPort])
				do: [:each | each closeAndDestroy]]! !


!NmServerManager class methodsFor: 'factory' stamp: 'mu 5/6/2003 01:38'!
soapServerSetup
	^ Smalltalk
		at: #SoapServerSetup
		ifAbsent: []! !

!NmServerManager class methodsFor: 'factory' stamp: 'mu 5/6/2003 01:38'!
warpServerSetup
	^ Smalltalk
		at: #NmRemoteServer
		ifAbsent: []! !


Object subclass: #NmTranscript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmTranscript class
	instanceVariableNames: 'isDebugging '!

!NmTranscript class methodsFor: 'class initialization' stamp: 'mu 4/11/2003 14:44'!
initialize
	"NmTranscript initialize"
	isDebugging _ false! !


!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:47'!
crShow: aString
	isDebugging ifTrue: [Transcript cr; show: aString]! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:44'!
isDebugging
	^isDebugging! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:47'!
show: aString
	isDebugging ifTrue: [Transcript show: aString]! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:44'!
toggleDebugging
	isDebugging _ isDebugging not! !


HttpUrl subclass: #NmUrl
	instanceVariableNames: 'isLocal ipAddress '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 15:35'!
host
	self authority isNil ifTrue: [authority _  ''].
	^self authority	! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/3/2002 10:26'!
host: aString 
	
	authority _ aString! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 3/23/2003 13:01'!
ipAddress
	^ ipAddress! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 2/25/2003 14:24'!
ipAddress: aValue 
	ipAddress _ ipAddress.
	! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 16:36'!
isLocal
	isLocal isNil
		ifTrue: [isLocal _ false].
	^ isLocal! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 16:36'!
isLocal: aBoolean
	isLocal _ aBoolean! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 3/23/2003 15:56'!
port
	port ifNil: [port _ NmSettings defaultWarpPort].
	^ port.! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/17/2003 14:49'!
port: anInteger
	port _ anInteger! !


!NmUrl methodsFor: 'comparing' stamp: 'mu 3/23/2003 13:15'!
= otherNmUrl 
	"'nm://localhost' asUrl = 'nm://127.0.0.1' asUrl"
	self class = otherNmUrl class ifFalse: [^ false].
	self port = otherNmUrl port ifFalse: [^ false].
	self path = otherNmUrl path ifFalse: [^ false].
	^ self hostId = otherNmUrl hostId! !

!NmUrl methodsFor: 'comparing' stamp: 'MU 10/3/2002 10:33'!
hash
	^ (self port hash hashMultiply + self path hash hashMultiply + self hostId hash hashMultiply) 




! !

!NmUrl methodsFor: 'comparing' stamp: 'MU 11/11/2002 16:07'!
hostId

	^ self hostOrIpAddress asString, ':', self port asString! !

!NmUrl methodsFor: 'comparing' stamp: 'mu 4/12/2003 19:38'!
truelyEquals: otherNmUrl 
	self class = otherNmUrl class
		ifFalse: [^ false].
	self host = otherNmUrl host
		ifFalse: [^ false].
	self port = otherNmUrl port
		ifFalse: [^ false].
	self path = otherNmUrl path
		ifFalse: [^ false].
	self ipAddress = otherNmUrl ipAddress
		ifFalse: [^ false].
	^ true! !


!NmUrl methodsFor: 'printing' stamp: 'MU 11/11/2002 15:55'!
csvString
	"'nm://localhost:37458' asUrl csvString"
	| stream |
	stream _ WriteStream on: String new.
	stream nextPutAll: self printString.
	^ stream contents! !

!NmUrl methodsFor: 'printing' stamp: 'mu 4/12/2003 19:37'!
displayString
	^ (self host isNil
			or: [self port isNil])
		ifTrue: [String new]
		ifFalse: [super toText]! !

!NmUrl methodsFor: 'printing' stamp: 'mu 3/10/2003 17:42'!
shortPrintString
	"'nm://localhost:37459' asUrl shortPrintString"
	"'nm://localhost:37458' asUrl shortPrintString"
	| stream |
	stream _ WriteStream on: String new.
	stream nextPutAll: self host.
	self port = NmSettings defaultWarpPort
		ifFalse: [stream nextPut: $:.
			stream nextPutAll: self port printString].
	^ stream contents! !


!NmUrl methodsFor: 'printing-sixx'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self toText.! !


!NmUrl methodsFor: 'testing' stamp: 'MU 11/11/2002 16:09'!
isIPAddressedUrl
	^ (NetNameResolver addressFromString: self host) notNil! !

!NmUrl methodsFor: 'testing' stamp: 'mu 4/15/2003 16:38'!
isNmUrl
	^true! !


!NmUrl methodsFor: 'initialize-release' stamp: 'MU 10/3/2002 10:43'!
initialize
	path _ #()! !

!NmUrl methodsFor: 'initialize-release' stamp: 'MU 2/25/2003 14:25'!
privateInitializeFromText: aString 
	super privateInitializeFromText: aString.
	"set host if possible"
	authority _ authority asLowercase.
	authority = '127.0.0.1'
		ifTrue: [authority _ 'localhost']
		ifFalse: [| tokens | 
			tokens _ authority findTokens: '.'.
			(tokens
					select: [:each | each isAllDigits
							and: [each asNumber < 256]]) size = 4
				ifTrue: [| hostname | 
					ipAddress _ authority.
					hostname _ NetNameResolver
								nameForAddress: (NetNameResolver addressFromString: authority)
								timeout: 15.
					authority _ hostname isNil
								ifTrue: [authority]
								ifFalse: [hostname asLowercase]]]! !


!NmUrl methodsFor: 'actions' stamp: 'mu 3/23/2003 13:15'!
hostOrIpAddress
	^ self host isNil
		ifTrue: [self ipAddress]
		ifFalse: [self host]! !

!NmUrl methodsFor: 'actions' stamp: 'mu 3/23/2003 13:14'!
ipAddressOrHost
	^ self ipAddress isNil
		ifTrue: [self host]
		ifFalse: [self ipAddress]! !

!NmUrl methodsFor: 'actions' stamp: 'mu 3/23/2003 12:46'!
resolve
	ipAddress _ NmResolver default
		resolveName: self host
		! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmUrl class
	instanceVariableNames: 'local '!

!NmUrl class methodsFor: 'constants'!
protcolIdentifier
	^ 'nm' copy.! !


!NmUrl class methodsFor: 'instance creation-sixx'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self absoluteFromText: (SixxXmlUtil characterDataFrom: sixxElement)! !


!NmUrl class methodsFor: 'instance creation' stamp: 'MU2 1/21/2003 18:40'!
createLocal
	"NmUrl local"
	| url |
	url _ (self protcolIdentifier , '://' , NmUtil localHostname , ':' , NmSettings warpPort printString) asUrl.
	^ url! !

!NmUrl class methodsFor: 'instance creation' stamp: 'MU 11/11/2002 15:57'!
fromCSVString: aString 
	"NmUrl fromCSVString: 'nm://localhost:37458/'"
	| stream urlString url |
	stream _ ReadStream on: aString.
	urlString _ stream upToEnd.
	url _ urlString asUrl.
	^ url! !

!NmUrl class methodsFor: 'instance creation' stamp: 'mu 3/23/2003 14:45'!
host: hostname port: portNumber
	| inst urlStr |
	inst _ self basicNew.
	urlStr _ self protcolIdentifier , '://' , hostname , ':' , portNumber asString.
	inst privateInitializeFromText: urlStr.
	^inst
	! !

!NmUrl class methodsFor: 'instance creation' stamp: 'MU 10/2/2002 20:26'!
new
	^super new initialize! !


!NmUrl class methodsFor: 'accessing' stamp: 'MU 10/3/2002 10:19'!
local
	local isNil ifTrue: [local _ self createLocal].
	^local! !


!NmUrl class methodsFor: 'claass initialization' stamp: 'MU 10/3/2002 12:44'!
initialize
	"NmUrl initialize"
	local _ nil! !


NmCSVReadWriter subclass: #NmWorldInfoReadWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldInfoReadWriter class
	instanceVariableNames: ''!


!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 3/17/2003 00:14'!
getCsvStringFromFile: fileNameString
	| readDir fileName |
	fileName _ (fileNameString endsWith: '.csv')
				ifTrue: [fileNameString]
				ifFalse: [fileNameString , '.csv'].
	readDir _ FileDirectory on: self defaultPath.
	(readDir fileExists: fileName)
		ifTrue: [| fileStream csvString | 
	
			[fileStream _ CrLfFileStream readOnlyFileNamed: (readDir fullNameFor: fileName).
			csvString _ fileStream contentsOfEntireFile]
				ensure: [fileStream
						ifNotNil: [fileStream close]].
			^ csvString]
		ifFalse: [^ nil]! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 3/17/2003 00:20'!
listAllCsvFileNamesFromDirectory
	| readDir | 
	readDir _ FileDirectory on: self defaultPath.
	(readDir directoryExists: readDir pathName)
		ifTrue: [| fileNames mapNames | 
			fileNames _ readDir fileNames. 
			mapNames _ fileNames
						select: [:each | '*.csv' match: each].
			^ mapNames]
		ifFalse: [^ #()]! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'my 4/9/2003 22:29'!
listMapCsvFileNamesFromDirectory
	| prefix |
	prefix _ NmAbstractSettings resolverPrefix.
	^self listAllCsvFileNamesFromDirectory reject: [:each | each beginsWith: prefix]! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/19/2003 16:02'!
putCsvString: csvString toFile: fileNameString 
	| writeFileStream fileName |
	fileName _ (fileNameString endsWith: '.csv')
				ifTrue: [fileNameString]
				ifFalse: [fileNameString , '.csv'].
	[[writeFileStream _ CrLfFileStream
				forceNewFileNamed: ((FileDirectory on: self defaultPath)
						fullNameFor: fileName)]
		on: CannotDeleteFileException
		do: [:ex | NmTranscript show: ex description. ^nil].
	writeFileStream
		ifNil: [self error: 'Wrong path or filename'.
			^ nil].
	writeFileStream nextPutAll: csvString]
		ensure: [writeFileStream
				ifNotNil: [writeFileStream close]]! !


!NmWorldInfoReadWriter class methodsFor: 'utilities' stamp: 'Mu 6/4/2003 02:30'!
defaultPath
	"Actually 'mapPath' should be 'worldInfoPath'"
	| path |
	path _ NmServerManager isMapAndNameServersInstalled
				ifTrue: [NmServerSettings mapPath]
				ifFalse: [NmSettings mapPath].
	^(path beginsWith: '.')
		ifTrue: [FileDirectory default pathName]
		ifFalse: [path]! !

!NmWorldInfoReadWriter class methodsFor: 'utilities' stamp: 'mu 5/19/2003 21:10'!
defaultPath: path
	"Actually 'mapPath' should be 'worldInfoPath'"
	NmServerManager isMapAndNameServersInstalled ifTrue: [^NmServerSettings mapPath: path].
	^NmSettings mapPath: path! !

NmAbstractSettings initialize!
NmTranscript initialize!
NmUrl initialize!